.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "3.3",
.\"     date            = "25 October 1999",
.\"     time            = "07:56:21 MDT",
.\"     filename        = "chkdelim.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 322 INSCC
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 585 1640, +1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "34051 627 2274 16323",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@ieee.org (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "delimiter check",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for chkdelim, the delimiter balance checking
.\"                        utility.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.TH CHKDELIM 1L "23 October 1999" "Version 3.3"
.if t .ds Bi B\s-2IB\s+2T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Bi BibTeX
.\"
.if t .ds La L\\h'-0.24m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds La LaTeX
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"===============================================
.SH "NAME"
chkdelim \- check delimiter balance
.\"===============================================
.SH "SYNOPSIS"
.B chkdelim
[
.B \-?
]
[
.B \-author
]
[
.B \-BibTeX
]
[
.B \-copyright
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.BI \-error-file " filename"
]
[
.B \-help
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
.if t .ti +\w'\fBchkdelim\fP\ 'u
[
.BI \-ignore " delimiters"
]
[
.B \-Lisp
]
[
.B \-nested
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-no-BibTeX
]
[
.B \-no-Lisp
]
[
.B \-no-nested
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
.if t .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-no-Nroff
]
[
.B \-no-page-reset
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-no-paragraph-reset
]
[
.B \-no-quote-check
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-no-Scribe
]
.if t .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-no-TeX
]
[
.B \-no-TeXinfo
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-Nroff
]
[
.BI \-output-file " filename"
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-page-reset
]
.if t .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-paragraph-reset
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-quote-check
]
[
.B \-Scribe
]
[
.B \-TeX
]
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.B \-TeXinfo
]
[
.B \-version
]
.if t .ti +\w'\fBchkdelim\fP\ 'u
.if n .ti +\w'\fBchkdelim\fP\ 'u
[
.IR "< infile" " or " " file1 file2 file3 .\|.\|."
]
.I "> outfile"
.\"===============================================
.SH DESCRIPTION
.PP
.B chkdelim
is a tool for detecting common delimiter errors in
electronic documents and computer programs.  It
filters a list of files, or its standard input if
no filenames are provided, matching group
delimiters: angle brackets, curly braces,
parentheses, square brackets, forward quotes
(apostrophes or acutes), backward quotes (graves),
quotation marks, and dollar signs (used in the
\*(Te\& typesetting system).
.PP
Warning messages are printed to
.I stdout
whenever unbalanced delimiters are found, giving
the delimiter and its line, column, and file
positions.  The output format is recognizable by
the GNU
.B emacs
.I "M-x compile"
command, making it easy to parse the warning
messages and jump to their locations with the
keystrokes
.IR "C-x `" (next-error).
.PP
Except in
.B \-Scribe
mode, a backslash preceding a delimiter prevents
it from being recognized as a delimiter.  This is
a suitable choice for \*(Te\& documents, as well
as for C-like programming languages and UNIX
shells.  Use the
.B \-ignore
option to override the special handling of
backslash.
.PP
If unbalanced delimiters are needed, it is often
possible to insert a matching delimiter in a
nearby comment so that the delimiter appears to
.B chkdelim
to be properly balanced.  This will reduce the
number of messages issued, so that the real
problems will be more evident.
.PP
.B chkdelim
exits with a success code (0 on UNIX) if no
warning messages are printed on
.IR stdout ;
otherwise, it exits with a failure code (1 on
UNIX).
.PP
.B chkdelim
recognizes, and handles transparently on all
systems, the three popular flavors of text file
line terminators: CR (Macintosh), CR LF (IBM PC
DOS and Microsoft Windows), and LF (UNIX).
.\"===============================================
.SH OPTIONS
Command-line options may be abbreviated to a
unique leading prefix, and letter case is
.I not
significant.  Options affect only the processing
of files that
.I follow
them on the command line.
.PP
Language-specific options
.RB ( \-BibTeX ,
.BR \-Lisp ,
.BR \-Nroff ,
.BR \-Scribe ,
.BR \-TeX ,
and
.BR \-TeXinfo ),
and their negations, should be given before other
options, because they reset many internal flags
that affect the handling of specific characters.
.PP
The leading hyphen that distinguishes an option
from a filename may be doubled, for compatibility
with GNU and POSIX conventions.  Thus,
.B \-author
and
.B \-\-author
are equivalent.
.PP
To avoid confusion with options, if a filename
begins with a hyphen, it must be disguised by a
leading absolute or relative directory path, e.g.,
.I /tmp/-foo
or
.IR ./-foo .
.\"-----------------------------------------------
.TP \w'\-no-paragraph-reset'u+3n
.B \-?
Display a brief help message on
.IR stderr ,
and exit immediately with a success return code.
Same as
.BR \-help .
.\"-----------------------------------------------
.TP
.B \-author
Display author information on
.IR stderr ,
and exit immediately with a success return code.
.\"-----------------------------------------------
.TP
.B \-BibTeX
Input is in \*(Bi\& format.
.IP
Processing is similar to that for
.BR \-TeX ,
with the addition of these features:
.RS
.TP \w'\(bu'u+1n
\(bu
`@' characters at the start of a line begin a
new paragraph, and restart the delimiter checks.
.TP
\(bu
Quotation marks are not significant when they are
embedded inside two or more brace levels.
.RE
.\"-----------------------------------------------
.TP
.B \-copyright
Display copyright information on
.IR stderr ,
and exit immediately with a success return code.
.\"-----------------------------------------------
.TP
.BI \-error-file " filename"
Specify an alternate error log file.  This is
primarily useful on operating systems that fail
to provide for redirection of
.IR stderr .
.\"-----------------------------------------------
.TP
.B \-help
Display a brief help message on
.IR stderr ,
and exit immediately with a success return code.
Same as
.BR \-? .
.\"-----------------------------------------------
.TP
.BI \-ignore " delimiters"
Specify one or more delimiter characters that are
to be ignored.  In the case of paired delimiters
(braces, brackets, parentheses), either, or both,
of a pair may be specified.
.IP
Since most delimiter characters have special
significance to command shells, it will usually be
necessary to protect them suitably from shell
interpretation, such as with backslashes, or
inside quoted strings.
.IP
Angle brackets are more commonly used for
less-than and greater-than symbols, rather than
<paired>, so
.BI \-ignore " \e<\e>"
will be a likely
.B chkdelim
option on UNIX systems.
.IP
When < and > are required in the
.B \-ignore
argument, they may be represented by L and G (for
less-than and greater-than).  This avoids the
danger of confusion with UNIX and IBM PC DOS
input- and output-file redirection, and gets
around the lack of support for protecting special
characters on IBM PC DOS command lines.
.\"-----------------------------------------------
.TP
.B \-Lisp
Input is in Lisp syntax.  This should be suitable
for most Lisp dialects, including Common Lisp,
Emacs Lisp, GNU Guile, Portable Standard Lisp, and
Scheme.
.IP
With this option, single quotes following
whitespace or an open parenthesis are ignored,
since they are presumably Lisp shorthand for the
.I quote
function:
.I (a 'b ('c))
is equivalent to
.I (a (quote b) ((quote c)))
.IP
Backslash quotes the next character, preventing it
from being considered as a possible delimiter.
.IP
A single quote between letters is ignored.
.IP
Angle brackets are ignored, since they are
function names in most Lisp dialects.
.IP
Files in those Lisp dialects that use a single
closing bracket to represent multiple closing
parenthesis will generate warnings in such cases.
.\"-----------------------------------------------
.TP
.B \-nested
Check for properly-nested delimiters.  This is the
default.
.\"-----------------------------------------------
.TP
.B \-no-BibTeX
Suppress any
.B \-BibTeX
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-Lisp
Suppress any
.B \-Lisp
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-nested
Suppress any
.B \-nested
option specified earlier on the command line.
This is sometimes useful to reduce the number of
warning messages.
.\"-----------------------------------------------
.TP
.B \-no-Nroff
Suppress any
.B \-Nroff
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-page-reset
Suppress any
.B \-page-reset
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-paragraph-reset
Suppress any
.B \-paragraph-reset
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-quote-check
Suppress any
.B \-quote-check
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-Scribe
Suppress any
.B \-Scribe
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-TeX
Suppress any
.B \-TeX
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-no-TeXinfo
Suppress any
.B \-TeXinfo
option specified earlier on the command line.
.\"-----------------------------------------------
.TP
.B \-Nroff
Input is in nroff/troff format.
.IP
Backslash quotes the next character, preventing it
from being considered as a possible delimiter.
\&\e*( is recognized so that it does not cause
warnings about unbalanced parentheses.
.IP
Quote handling is the same as for the
.B \-TeX
option.
.\"-----------------------------------------------
.TP
.BI \-output-file " filename"
Specify an alternate output file.  This is
primarily useful on operating systems that fail
to provide for redirection of
.IR stdout .
.\"-----------------------------------------------
.TP
.B \-page-reset
At start of page, indicated by a formfeed
character, issue any needed warning messages, and
then forget any delimiter imbalances.
.\"-----------------------------------------------
.TP
.B \-paragraph-reset
At end of paragraph, which is a line that is
empty, or contains only whitespace, issue any
needed warning messages, and then forget any
delimiter imbalances.  This option is often useful
to limit the number of messages that can
appear.
.\"-----------------------------------------------
.TP
.B \-quote-check
Override the default handling of forward, or
close, quote (apostrophe) selected by
.BR \-BibTeX ,
.BR \-Nroff ,
.BR \-Scribe ,
.BR \-TeX ,
or
.BR \-TeXinfo ,
so that open and close quotes will be expected to
occur in pairs, instead of close quote receiving
special handling for its use in abbreviations,
possessives, and contractions.
.\"-----------------------------------------------
.TP
.B \-Scribe
Input is in Scribe format.
.IP
`@' quotes the next character, preventing it
from being considered as a possible delimiter.
.IP
Backslash is an ordinary character.
.IP
Quote handling is the same as for the
.B \-TeX
option.  In particular, this means that use of
legal Scribe commands of the form
.I @NAME'arg'
and
.I @NAME`arg`
will produce warning messages.
.\"-----------------------------------------------
.TP
.B \-TeX
Input is in \*(Te\& or \*(La\& format.
.IP
Backslash quotes the next character, preventing it
from being considered as a possible delimiter.
.IP
Unbackslashed dollar signs must be paired, either
.I $ \|.\|.\|. $
or
.I $$ \|.\|.\|. $$,
for inline and displayed mathematics, and the
contents may not include an empty line.  Without
this option, dollar characters are always ignored.
.IP
Forward and backward quotes are checked to verify
that they appear in open/close pairs: \&`.\|.\|.'
and \&``.\|.\|.'', instead of in the forms
\&`.\|.\|.` and \&'.\|.\|.' used in computer
programming languages.
.IP
For
.B \-TeX
mode
.IR only ,
the special ligatures ?` and !` for Spanish
inverted query and exclamation mark are
recognized: they do not cause
unbalanced-open-quote warnings.
.IP
The following special handling of quotes is in
effect unless it has been suppressed by a
.B \-quote-check
command-line option.
.RS
.IP
Forward quotes between letters or digits are
ignored, so that possessives
.RI ( Alice's )
and elisions
.RI ( O'Neill )
do not raise bogus warnings.
.IP
A forward quote between a close brace and an
.I s
is assumed to be a possessive, as in
.IR "{Cook}'s Voyage" .
.IP
Forward quotes between a space and a digit, or
beginning-of-line and a digit, are also ignored,
so that text like ``Supercomputing '95'' does not
raise warnings.
.IP
A forward quote preceding a lone
.I s
or
.I t
is assumed to reflect Dutch use, as in
the personal name
.I "in 't Hout"
or the street name
.I "A. v. 's Gravesandestraat" .
.RE
.\"-----------------------------------------------
.TP
.B \-TeXinfo
Input is in GNU \*(Te\&info format.
.IP
`@' quotes the next character, preventing it
from being considered as a possible delimiter.
.IP
Quote handling is the same as for the
.B \-TeX
option.
.\"-----------------------------------------------
.TP
.B \-version
Display version information on
.IR stderr ,
and exit immediately with a success return code.
.\"===============================================
.SH BUGS
In \*(Te\& documents, quotation marks ".\|.\|."
should be used only inside verbatim environments,
but
.B chkdelim
does not recognize such environments, so it will
only warn if quotation marks are unbalanced.
\*(La\& users are advised to employ the
.BR lacheck (1)
utility to detect incorrect use of quotation
marks.
.\"===============================================
.SH "SEE ALSO"
.BR lacheck (1).
.\"===============================================
.SH AUTHOR
.nf
Nelson H. F. Beebe, Ph.D.
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Tel: +1 801 581 5254
FAX: +1 801 585 1640, +1 801 581 4148
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP, \fCbeebe@ieee.org\fP (Internet)
WWW URL: http://www.math.utah.edu/~beebe
.fi
.\"===============================================
.SH AVAILABILITY
The source code distribution for
.B chkdelim
is freely available, and may be found
on the World-Wide Web at
.RS
.I \fChttp://www.math.utah.edu/pub/misc/index.html#chkdelim\fP
.RE
or equivalently, via anonymous ftp at
.RS
.I \fCftp://ftp.math.utah.edu/pub/misc/chkdelim-x.y.tar.gz\fP
.I \fCftp://ftp.math.utah.edu/pub/misc/chkdelim-x.y.zip\fP
.I \fCftp://ftp.math.utah.edu/pub/misc/chkdelim-x.y.zoo\fP
.RE
where
.I x.y
is a version number.
.\"===================[The End]===================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
